//+------------------------------------------------------------------+
//|                                                     SubChart.mq4 |
//|                                                           mladen |
//|                                               mladenfx@gmail.com |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 DimGray
#property indicator_style1 STYLE_DOT

//
//
//
//
//

extern string ForSymbol        = "";
extern string TimeFrame        = "Current time frame";
extern int    BarsToDisplay    = 250;
extern color  colorBarDown     = Red;
extern color  colorBarUp       = Green;
extern color  colorBarNeutral  = DimGray;
extern color  colorWickUp      = DimGray;
extern color  colorWickDown    = DimGray;
extern color  colorWickNeutral = DimGray;
extern int    widthWick        = 1;
extern int    widthBody        = 3;
extern string UniqueID         = "SubChart1";

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];

int    timeFrame;
string forSymbol;
string shortName;
int    window;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer5);
   SetIndexBuffer(1,buffer1); SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(2,buffer2); SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(3,buffer3); SetIndexStyle(3,DRAW_NONE);
   SetIndexBuffer(4,buffer4); SetIndexStyle(4,DRAW_NONE);

   //
   //
   //
   //
   //
   
   forSymbol = ForSymbol;
   if (forSymbol == "")
       forSymbol = Symbol(); 
         timeFrame = stringToTimeFrame(TimeFrame);  
         shortName = UniqueID+" "+forSymbol+" - "+timeFrameToString(timeFrame);
            IndicatorShortName(shortName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   for (int i = ObjectsTotal()-1; i >= 0; i--)
   {
      string oName = ObjectName(i); if (StringFind(oName, UniqueID, 0) >= 0) ObjectDelete(oName);
   }
   return (0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   window = WindowFind(shortName);
   
   //
   //
   //
   //
   //
   
      int displayBars = MathMin(BarsToDisplay,Bars-1);
      for (int i=0; i<displayBars; i++)
      {
         double priceO =  iOpen(forSymbol,timeFrame,i);
         double priceC = iClose(forSymbol,timeFrame,i);
         double priceH =  iHigh(forSymbol,timeFrame,i);
         double priceL =   iLow(forSymbol,timeFrame,i);
            buffer1[i] = (priceH);
            buffer2[i] = (priceL);
            buffer3[i] = (priceO);
            buffer4[i] = (priceC);
            buffer5[i] = buffer4[0];

               color  theBarColor  = colorBarNeutral;
               color  theWickColor = colorWickNeutral;
                  if (priceC<priceO) { theBarColor = colorBarDown; theWickColor = colorWickDown; }
                  if (priceC>priceO) { theBarColor = colorBarUp;   theWickColor = colorWickUp;   }
                     drawBar(Time[i],priceH,priceL,priceO,priceC,theBarColor,theWickColor);
      }
      while(i < Bars && buffer1[i] != EMPTY_VALUE)
      {
            buffer1[i] = EMPTY_VALUE;
            buffer2[i] = EMPTY_VALUE;
            buffer3[i] = EMPTY_VALUE;
            buffer4[i] = EMPTY_VALUE;
            buffer5[i] = EMPTY_VALUE;
               ObjectDelete(UniqueID+TimeToStr(Time[i])+"w");
               ObjectDelete(UniqueID+TimeToStr(Time[i])+"b");
            i++;
      }
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void drawBar(int bTime, double prHigh, double prLow, double prOpen, double prClose, color barColor, color wickColor)
{
   string oName;
          oName = UniqueID+TimeToStr(bTime)+"w";
            if (ObjectFind(oName) < 0) ObjectCreate(oName,OBJ_TREND,window,bTime,0,bTime,0);
                 ObjectSet(oName, OBJPROP_PRICE1, prHigh);
                 ObjectSet(oName, OBJPROP_PRICE2, prLow);
                 ObjectSet(oName, OBJPROP_COLOR, wickColor);
                 ObjectSet(oName, OBJPROP_WIDTH, widthWick);
                 ObjectSet(oName, OBJPROP_RAY, false);
                 ObjectSet(oName, OBJPROP_BACK, true);
           
         oName = UniqueID+TimeToStr(bTime)+"b";
            if (ObjectFind(oName) < 0)ObjectCreate(oName,OBJ_TREND,window,bTime,0,bTime,0);
                 ObjectSet(oName, OBJPROP_PRICE1, prOpen);
                 ObjectSet(oName, OBJPROP_PRICE2, prClose);
                 ObjectSet(oName, OBJPROP_COLOR, barColor);
                 ObjectSet(oName, OBJPROP_WIDTH, widthBody);
                 ObjectSet(oName, OBJPROP_RAY, false);
                 ObjectSet(oName, OBJPROP_BACK, true);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}